cheat = {
	cheats = {
		clique = {
			name = "point and clique",
			tooltip = "while in-game, spawn an ogmo wherever you click",
			active = false
		},
		nifty = {
			name = "nifty",
			tooltip = "draw on the menu with your mouse (ps1 controllers not supported)",
			active = false,
			imatoggle = true,
			action = function(self)
				cheat.toggle(self)
				for y=1, menu.height do
					menu.niftyimg[y] = {}
					for x=1, menu.width do
						menu.niftyimg[y][x] = false
					end
				end
			end
		},
		rhubarb = {
			name = "rhubarb menu",
			tooltip = "it's fairly self-explanatory",
			action = function()
				menu.changeSubstate("rhubarb")
			end
		},
		--[[
		ransom = {
			name = "ransom in the sand",
			tooltip = "play Art of Noise - Ransom in the Sand",
			action = function()
				if audio.activesong ~= "ransom in the sand" then
					audio.playsong("ransom in the sand", true)
				end
			end
		},
		]]
		boing = {
			name = "boing",
			tooltip = "play boing",
			action = function()
				if audio.activesong ~= "boing" then
					audio.playsong("boing", true)
				end
			end
		},
		scroller1 = {
			name = "scroll to move",
			tooltip = "use scrollwheel to move ogmo up/down. hold right click and it moves left/right",
			active = false
		},
		agodami = {
			name = "god mode",
			tooltip = "ogmos only die from falling off-screen or pressing R",
			active = false
		},
		youreglue = {
			name = "i'm rubber",
			tooltip = "bouncy surfaces always forever",
			active = false
		},
		stackem = {
			name = "stack 'em to the heavens",
			tooltip = "levels are vertically separated into their individual layers",
			active = false
		},
		jumper4imaginary = {
			name = "Jumper 4 Imaginary",
			tooltip = "i cannot believe it",
			imatoggle = true,
			active = false,
			action = function(self)
				cheat.toggle(self)
				if self.active then
					menu.changelogo("J4I Logo")
					if audio.activesong ~= "imagination" then
						print("playing imagination from jumper4imaginry cheat action")
						audio.playsong("imagination")
					end
				else
					menu.changelogo("J4R Logo 2x")
					if audio.activesong ~= "hub" then
						print("playing hub from jumper4imaginry cheat action")
						audio.playsong("hub")
					end
				end
			end
		},
		smallsteps = {
			name = "small steps",
			tooltip = "move ogmos by 1 px, ignoring walls, using the [ and ] keys",
			active = false
		},
		ogmolith = {
			name = "ogmolith",
			tooltip = "become the ogmolith",
			action = function()
				game.ogmoskin = "ogmolith"
				game.ogmosnapto = 16
				_G["ogmo"].quads = ogmos[game.ogmoskin].quads --this was orignially located somewhere with a local "ogmo" variable so it needed to specify _G
			end
		},
		widescreen = {
			name = "widescreen",
			tooltip = "make it wider",
			imatoggle = true,
			active = false,
			action = function(self)
				cheat.toggle(self)
				if self.active then
					game.width = 1024
					menu.width = 1024
				else
					game.width = 640
					menu.width = 640
				end
				resizeWindow(menu.width, menu.height)
			end
		},
		wrongway = {
			name = "wrong way",
			tooltip = "launchers now spin clockwise",
			active = false
		},
		jumparound = {
			name = "jump up and get down",
			tooltip = "ogmo attempts to jump whenever possible",
			active = false
		},
		oldskoolbutlikewithak = {
			name = "oldskool but, like, with a k",
			tooltip = "old skool friction & acceleration - stop and start instantly",
			active = false
		},
		ogmobleatsforplentyofcheats = {
			name = "ogmo bleats for plenty of cheats",
			tooltip = "when used from cheats menu, unlocks ALL the cheats!",
			action = function()
				if menu.ischeatmenu then
					audio.playsfx("cheat")
					local lockedcheats_old = table.copy(cheat.lockedcheats)
					for i,v in ipairs(lockedcheats_old) do
						if not cheat.cheats[v].hidden then
							cheat.unlock(v)
						end
					end
					menu.changed.unlockedcheats = true
					menu.refresh()
				end
			end
		},
		ogmoshoutsmakecheatsgoout = {
			name = "ogmo shouts \"make cheats go out\"",
			tooltip = "when used from cheats menu, disables & re-locks ALL the cheats",
			action = function()
				if menu.ischeatmenu then
					audio.playsfx("cheat")
					local activecheats_old = table.copy(cheat.activecheats)
					for i,v in ipairs(activecheats_old) do
						cheat.disable(v)
					end
					
					cheat.unlockedcheats = {}
					cheat.lockedcheats = {}
					cheat.lockedcheats_withvox = {}
					cheat.activecheats = {}
					
					local _cheatswithvox = love.filesystem.getDirectoryItems("audial/sfx/vox/ogmosays/cheats")
					local cheatswithvox = {}
					for k,v in pairs(_cheatswithvox) do
						cheatswithvox[v] = true
					end
					
					for k,v in pairs(cheat.cheats) do
						v.unlocked = false
						table.insert(cheat.lockedcheats, k)
						if cheatswithvox[k .. ".ogg"] then table.insert(cheat.lockedcheats_withvox, k) end
					end
					menu.changed.unlockedcheats = true
					menu.back()
				end
			end
		},
		frameadvance = {
			name = "frame advance",
			tooltip = "press F to toggle frame-by-frame mode, and press G to advance to next frame",
			imatoggle = true,
			active = false,
			action = function(self)
				cheat.toggle(self)
				if self.active then
					allowframeadvance = true
				else
					allowframeadvance = false
				end
			end
		},
		legacy144hz = {
			name = "legacy 144hz mode",
			tooltip = "game runs twice as fast",
			active = false
		},
		highlyamusing = {
			name = "highly amusing",
			tooltip = "when ogmo jumps, the level finds this highly amusing",
			active = false
		},
		sisehtnysotop = {
			name = "sisehtnysotop",
			tooltip = "haha you said sisehtnysotop",
			hidden = true,
			action = function()
				ih8ui.queueBox(boxes.sisehtnysotop)
			end
		},
		fastdingbats = {
			name = "fast dingbats",
			--tooltip = "the symbols outside the viewport change rapidly",
			tooltip = "the delay for the symbols outside the viewport to change is much shorter",
			active = false
		},
		lenientwalljumps = {
			name = "lenient walljumps",
			tooltip = "adds extra time to walljump after hitting a wall",
			active = false
		},
		theincredulousabilitytoglanceupwardswhilstnotyetfullyatastop = {
			name = "the incredulous ability to glance upwards whilst not yet fully at a stop",
			tooltip = "the incredulous ability to glance upwards whilst not yet fully at a stop",
			active = false
		},
		--[[
		thetippingpoint = {
			name = "the tipping point",
			tooltip = "get handy tips when you enter the editor!",
			active = false
		},
		]]
	},
	unlockedcheats = {}, --set in love.load
	lockedcheats = {}, --set in love.load
	lockedcheats_withvox = {}, --set in love.load
	activecheats = {}, --set in love.load
	
	get = function(name)
		if cheat.cheats[name] then return cheat.cheats[name] end
		return false
	end,
	isactive = function(name)
		if cheat.cheats[name] and cheat.cheats[name].active then return true end
		return false
	end,
	isunlocked = function(name)
		if cheat.cheats[name] and cheat.cheats[name].unlocked then return true end
		return false
	end,
	unlock = function(name)
		table.insert(cheat.unlockedcheats, name)
		cheat.cheats[name].unlocked = true
		for i,v in ipairs(cheat.lockedcheats) do
			if v == name then
				table.remove(cheat.lockedcheats, i)
				break
			end
		end
		for i,v in ipairs(cheat.lockedcheats_withvox) do --this redundancy could potentially be eliminated with a third table that maps indexes in lockedcheats to indexes in lockedcheats_withvox but is it worth the hassle?
			if v == name then
				table.remove(cheat.lockedcheats_withvox, i)
				break
			end
		end
	end,
	enable = function(thischeat)
		local thischeat = thischeat
		if type(thischeat) == "string" then
			thischeat = cheat.cheats[thischeat]
		end
		if thischeat.active == nil then
			print("whoops")
			print(thischeat)
			if type(thischeat) == "table" then
				print(thischeat.name)
			end
			error("tried to enable a non-bool cheat")
		end
		if not thischeat.active then
			table.insert(cheat.activecheats, thischeat.key)
			menu.changed.activecheats = true
		end
		thischeat.active = true
	end,
	disable = function(thischeat)
		local thischeat = thischeat
		if type(thischeat) == "string" then
			thischeat = cheat.cheats[thischeat]
		end
		if thischeat.active == nil then
			print("whoops")
			print(thischeat)
			if type(thischeat) == "table" then
				print(thischeat.name)
			end
			error("tried to disable a non-bool cheat")
		end
		if thischeat.active then
			local removeindex = 0
			for i,v in ipairs(cheat.activecheats) do
				if v == thischeat.key then
					removeindex = i
					break
				end
			end
			if removeindex ~= 0 then
				table.remove(cheat.activecheats, removeindex)
				menu.changed.activecheats = true
			else
				print("disabled a cheat that isn't on active list? " .. thischeat.key)
			end
		end
		thischeat.active = false
	end,
	toggle = function(thischeat)
		local thischeat = thischeat
		if not thischeat then error("a cheat is nil", 2) end
		if type(thischeat) == "string" then
			thischeat = cheat.cheats[thischeat]
		end
		if thischeat.active == nil then
			print("whoops")
			print(thischeat)
			if type(thischeat) == "table" then
				print(thischeat.name)
			end
			error("tried to toggle a non-bool cheat")
		end
		if thischeat.active then cheat.disable(thischeat)
		else cheat.enable(thischeat) end
	end,
	act = function(thischeat)
		local thischeat = thischeat
		if type(thischeat) == "string" then
			thischeat = cheat.cheats[thischeat]
		end
		if thischeat.action == nil then
			print("whoops")
			print(thischeat)
			if type(thischeat) == "table" then
				print(thischeat.name)
			end
			error("tried to act a non-function cheat")
		end
		thischeat.action(thischeat)
	end,
	invoke = function(thischeat)
		if type(thischeat) ~= "table" then error("invoking a nonexistent cheat (of type " .. type(thischeat) .. ")", 2) end
		if thischeat.action ~= nil then cheat.act(thischeat)
		elseif thischeat.active ~= nil then cheat.toggle(thischeat) end
	end
}
for k,thischeat in pairs(cheat.cheats) do
	thischeat.key = k
end