dingbats = {
	img = graphics.load("ui/dingbats"),
	quads = {},
	map = {},
	chance = 0.5,
	decaytimer = 60,
	decaychance = 0.1,
	lastviewportw = 0,
	lastviewporth = 0,
}

for y=0, dingbats.img:getHeight() - 16, 16 do
	for x=0, dingbats.img:getWidth() - 16, 16 do
		table.insert(dingbats.quads, quad(x, y, 16, 16, dingbats.img))
	end
end

function dingbats.place()
	print("placing dingbats")
	local dingbatsplaced = 0
	for y=1, #game.dingbats do
		for x=1, #game.dingbats[y] do
			dingbatsplaced = dingbatsplaced + 1
			if love.math.random() < game.dingbatchance then
				dingbatsplaced = dingbatsplaced + 1
				game.dingbats[y][x] = love.math.random(1, #game.dingbatquads)
			else
				game.dingbats[y][x] = false
			end
		end
	end
	print("placed " .. tostring(dingbatsplaced) .. " dingbats")
end

function dingbats.initMaps()
	print("initializing dingbats maps")
	dingbats.map = {}
	for y=1, game.height / 16 do
		dingbats.map[y] = {}
		for x=1, game.width / 16 do
			dingbats.map[y][x] = false
		end
	end
end

dingbats.initMaps()