--on right-side collision, if the object is ogmo AND IT IS MOVING LEFT, then do the pushy stuff (ogmo merely having momentum shouldn't be enough)
--also, crates fall at a fixed speed instead of accelerating downward - try 4 pixels down per frame
--also also deal with snapto shit much later (should be fake_x and x instead of x and x_clamped, and x snaps to fake_x during pushing logic)
  --(bit late for that)

--[[TODO

loop tmbg - rolling O (O, not 0)
i'm like 99% sure it loops]]

crate = mob:new()

local img = graphics.load("crate")

crate.quads = {
	["wood"] = quad(0,  0, 16, 16, img),
	["iron"] = quad(16, 0, 16, 16, img),
	["turbo"] = quad(32, 0, 16, 16, img),
	["tnt"] = quad(48, 0, 16, 16, img),
}

function crate.editordraw(x, y, options)
	local kind = options["kind"] or "wood"
	love.graphics.draw(graphics.load("crate"), crate.quads[kind], x, y)
end

function crate:init(x, y, kind, speed)
	self.type = "crate"
	self.x = x
	self.y = y
	self.y_clamped = y
	self.x_clamped = x
	self.hmom = 0
	self.vmom = 0
	self.width = tilesize
	self.height = tilesize
	self.solid = true
	self.kind = kind
	self.speed = speed
	self.gravity = 4
	self.crushduckingogmo = true
	self.dropheight = 0
	self.canride = true
	self.wasnudged = false
	self.nudgekludge = 0
end

function crate:setup(x, y, options, level, edge, tags)
	local kind = options["kind"] or "wood"
	local speed = 1
	if kind == "turbo" then speed = 8 end
	return crate:new(x, y, kind, speed)
end

function crate:update()
	self.hmom = 0
	self.vmom = self.gravity
	--collision
	local position
	local verticaled
	local verticaledby
	
	verticaled, position, verticaledby = mobtools.doCollisionScan("vertical", self)
	
	if position == nil then
		self.y = self.y + self.vmom
		self.dropheight = self.dropheight + self.vmom
		self.y_clamped = math.floor(self.y + .5)
	else
		self.y = position
		if self.y ~= self.y_clamped then self.y_clamped = math.floor(self.y + .5) end
		local boomed = false
		local bridgenudged = false
		for _,collider in ipairs(verticaledby) do
			if self.dropheight > 8 and self.kind == "tnt" then
				if not collider.indestructible then
					boomed = true
					if collider.onBoom then
						collider:onBoom()
					else
						if collider.istile then
							local tile = collider
							table.remove(self.level.tilemap[tile.y_tiled][tile.x_tiled], tile.i)
						else
							collider.irrelevant = true
							collider.solid = false
						end
					end
				end
			end
			if collider.onCollide then
				collider:onCollide(self, verticaled)
			end
		end
		if boomed then
			self.irrelevant = true
			self.solid = false
			self:playsfx("tnt boom")
		end
		self.dropheight = 0
	end
	if self.y > self.level.height then self.solid = false; self.irrelevant = true end
end

function crate:onCollide(collidee, side)
	if self.kind ~= "iron" then
		local pushed = false
		local stucktocrate = collidee["stuck" .. side] --for crate jumpppad logic
		if collidee.type == "ogmo" then
			if side == "left" and ((not collidee:notWalkingLeft()) or stucktocrate) then
				pushed = "left"
				self.hmom = -1 * self.speed
			elseif side == "right" and ((not collidee:notWalkingRight()) or stucktocrate) then
				pushed = "right"
				self.hmom = 1 * self.speed
			end
		end
		if self.dropheight ~= 0 then pushed = false end
		if pushed and not self.level:checktemp("platformed", self) then --double-check to see if the crate isn't in midair - unless it just got carried by a platform. if we don't skip in that case, then it becomes impossible to push crates off of lightbridge platforms for some reason
			local verticaled = mobtools.doCollisionScan("vertical", self)
			if verticaled ~= "down" then pushed = false end
		end
		if pushed then
			local collideefree = true
			if #collidee.walledby > 1 then
				collideefree = false
				--[[
				for i,v in ipairs(collidee.walledby) do
					if v.type ~= "crate" then
						collideefree = false
						break
					end
				end
				]]
			end
			
			if collideefree then
				local walled, position, walledby = mobtools.doCollisionScan("horizontal", self)
				
				if position == nil then
					self.x = self.x + self.hmom
					self.x_clamped = math.floor(self.x + .5)
					if not stucktocrate then collidee.tempmaxspeed = self.speed end
					collidee.x = collidee.x + self.hmom
					if not stucktocrate then collidee.hmom = self.hmom end
				else
					self.hmom = 0
					if not stucktocrate then collidee.hmom = 0 end
					self.x = position
					self.x_clamped = math.floor(self.x + .5)
					if pushed == "left" then
						collidee.x = self.x + self.width
					else
						collidee.x = self.x - collidee.width
					end
					for _,collider in ipairs(walledby) do
						if collider.onCollide then
							collider:onCollide(self, walled)
						end
					end
				end
				self.level:updateobjmap(self)
			end
		end
	end
end

function crate:draw()
	love.graphics.draw(graphics.load("crate"), crate.quads[self.kind], self.x_clamped, self.y_clamped)
end

return crate