j4rdebug = {}
j4r = j4rdebug

j4r.get = function(objtype, occurrence, field)
	if type(field) ~= "string" then
		print("field should be in a string")
		return
	end
	if type(occurrence) ~= "number" then
		print("occurrence should be a number")
		return
	end
	if type(objtype) == "table" then
		objtype = objtype.type
	end
	local level = game.activelevels[1]
	local occurrences = 0
	for i,v in ipairs(level.objects) do
		if v.type == objtype then
			occurrences = occurrences + 1
		end
		if occurrences == occurrence then
			print(v[field])
			return v[field]
		end
	end
	print("[" .. tostring(occurrences) .. " occurrences]")
end

j4r.ogmo = function(field)
	j4r.get("ogmo", 1, field)
end

j4r.set = function(objtype, occurrence, field, value)
	if type(objtype) == "table" then
		objtype = objtype.type
	end
	local level = game.activelevels[1]
	local occurrences = 0
	local success = false
	for i,v in ipairs(level.objects) do
		if v.type == objtype then
			occurrences = occurrences + 1
			if occurrences == occurrence then
				v[field] = value
				success = true
			end
		end
	end
	if success then print("done"); end
	print("[" .. tostring(occurrences) .. " occurrences]")
end

j4r.level = function()
	return game.activelevels[1]
end

j4r.traverse = function(t)
	for k,v in pairs(t) do print(k,v) end
end

traverse = j4r.traverse

--not useful
--[[

function whine(msg)
	local t = {}
	local info = debug.getinfo(2,"n")
	t[1] = info.namewhat
	t[2] = " "
	t[3] = info.name or "(?)"
	t[4] = ": "
	t[5] = msg
	print(table.concat(t))
end

do
	local test = {}
	test.dowhine = function()
		whine("whine test!")
	end
	test.dowhine()
	local whinemaker = function()
		return (function(self) whine("who am i") end)
	end
	(whinemaker())()
end
]]