mobtools = {}

--"why are there live mealworms in your code. i opened the collision detection code and now they're crawling inside my computer"
--"oh that, idk it just works"
--MEALWORM ~~~~~~~

--[[
function mobtools.collideAgainstThings(mob)

end

function mobtools.fetchProjectedPosition(mob)

end
]]

--in retrospect "dx" and "dy" might've been better names than "hmom" and "vmom", if the d is taken to mean delta
function mobtools.doCollisionScan(axis, collider, ignoreflush)
	if not collider.vmom then collider.vmom = 0 end
	if not collider.hmom then collider.hmom = 0 end
	local caughtobjects = {}
	
	--level = level or collider.level --never used
	local level = collider.level
	if not level then error("collision scan for something with no level?", 2) end
	--this could still use some more optimization (e.g. determine what rows/columns to scan based on collider's position and momentum without iterating through them first)
	local dir = "none"
	if axis == "horizontal" then
		if collider.hmom < 0 then dir = "left"
		elseif collider.hmom > 0 then dir = "right" end
	elseif axis == "vertical" then
		if collider.vmom < 0 then dir = "up"
		elseif collider.vmom > 0 then dir = "down" end
	end
	local collisiondir = "none"
	local suggestedposition = nil --where collisionscan suggests the collider's x should be if the collider collides with something. this will only ever be one number (or nil if no collision occurs) since collisionscan only works in one axis at a time
	local collidees = {}
	local function updateValuesToReturn (newcollisiondir, newsuggestedposition, newcollidees) --if you change this, change the matching function in doCollisionCheck
		if collisiondir == "none" then collisiondir = newcollisiondir end
		
		--make sure suggested position is always whichever position would make the player collide earlier
		if newsuggestedposition ~= nil then
			if suggestedposition == nil then suggestedposition = newsuggestedposition else
				if     (dir == "left"  or dir == "up") then
					if newsuggestedposition > suggestedposition then
						suggestedposition = newsuggestedposition
						collidees = {}
					elseif newsuggestedposition < suggestedposition then return end
				elseif (dir == "right" or dir == "down") then
					if newsuggestedposition < suggestedposition then
						suggestedposition = newsuggestedposition
						collidees = {}
					elseif newsuggestedposition > suggestedposition then return end
				end
			end
		end
		
		if newcollidees == nil then print("newcollidees is nil"); newcollidees = {} end
		
		for k,v in ipairs(newcollidees) do
			table.insert(collidees, v)
		end
	end
	local collider_rightedge = (collider.x) + collider.width
	local collider_leftedge = (collider.x)
	local collider_top = (collider.y)
	local collider_bottom = (collider.y) + collider.height
	
	if collider_rightedge < (1/16) then collider_rightedge = (1/16) end
	if collider_top > (collider.level.height - (1/16)) then collider_top = (collider.level.height - (1/16)) end
	if collider_leftedge > (collider.level.width - (1/16)) then collider_leftedge = (collider.level.width - (1/16)) end
	if collider_bottom < (1/16) then collider_bottom = (1/16) end
	
	if (axis == "horizontal" and collider.hmom ~= 0) or (axis == "vertical" and collider.vmom ~= 0) then
		
		--calculate bounds for iteration
		local topbound = collider_top
		local bottombound = collider_bottom
		if axis == "vertical" then --only bother adding vertical momentum to the bounds if we're actually checking where the player ends up after moving vertically
			if collider.vmom > 0 then
				topbound = collider_bottom + 1 --add 1 to topbound and bottombound because we don't care about collisions on the tile we're moving from. 
				bottombound = collider_bottom + 1 + collider.vmom
			elseif collider.vmom < 0 then
				topbound = collider_top - 1 + collider.vmom
				bottombound = collider_top - 1
			end
		end
		--convert pixel position to tile position
		topbound = math.floor(((topbound) / tilesize)) + 1 -- the +1 is due to table indexing starting at 1
		bottombound = math.ceil(((bottombound) / tilesize)) + 1
		
		
		
		local leftbound = collider_leftedge
		local rightbound = collider_rightedge
		if axis == "horizontal" then
			if collider.hmom > 0 then
				leftbound = collider_rightedge + 1
				rightbound = collider_rightedge + 1 + collider.hmom
			elseif collider.hmom < 0 then
				leftbound = collider_leftedge - 1 + collider.hmom
				rightbound = collider_leftedge - 1
			end
		end
		leftbound = math.floor(((leftbound) / tilesize)) + 1
		rightbound = math.ceil(((rightbound) / tilesize)) + 1
		
		--test
		--  rightbound = rightbound + 1
		--  bottombound = bottombound + 1
		--end test
		
		if topbound < 1 then topbound = 1 end
		if bottombound > #level.tilemap then bottombound = #level.tilemap end
		if leftbound < 1 then leftbound = 1 end
		if rightbound > #level.tilemap[1] then rightbound = #level.tilemap[1] end
		
		if axis == "horizontal" then
			if (not collider.collisioncondition) or collider:collisioncondition("levelborder", axis) then
				--colliding against the level borders
				if collider_rightedge + collider.hmom >= level.width and dir == "right" then
					updateValuesToReturn("right", level.width - collider.width, {tiles["levelborder"]})
				elseif collider_leftedge + collider.hmom <= 0 and dir == "left" then
					updateValuesToReturn("left", 0, {tiles["levelborder"]})
				end
			end
		elseif axis == "vertical" then
			if (not collider.collisioncondition) or collider:collisioncondition("levelborder", axis) then
				if level.options.bottombordersolid and collider_bottom + collider.vmom >= level.height and dir == "down" then
					updateValuesToReturn("down", level.height - collider.height, {tiles["levelborder"]})
				elseif collider_top + collider.vmom <= 0 and dir == "up" then
					updateValuesToReturn("up", 0, {tiles["levelborder"]})
				end
			end
		end
		if axis then
			for y_tiled=topbound, bottombound do
				for x_tiled=leftbound, rightbound do
					--mark((x_tiled - 1) * tilesize, (y_tiled - 1) * tilesize)
					for i=1, #level.tilemap[y_tiled][x_tiled] do
						local content = level.tilemap[y_tiled][x_tiled][i]
						if type(content) == "string" then
							local tilename = content
							local tile = table.copy(tiles[content])
							if (not tile.fake) and (tile.solid or (collider.collidewith and collider.collidewith[content])) then
								local actuallyactive = true
								local thing = tile
								if thing.color then
									if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
									if thing.color_inverse then actuallyactive = not actuallyactive end
								end
								if actuallyactive then
									tile.type = tilename
									tile.istile = true
									tile.x_tiled = x_tiled
									tile.y_tiled = y_tiled
									tile.i = i
									tile.x = ((x_tiled - 1) * tilesize) + (tile.hitboxXoffset or 0)
									tile.y = ((y_tiled - 1) * tilesize) + (tile.hitboxYoffset or 0)
									tile.hmom = 0
									tile.vmom = 0
									tile.width = tile.hitboxwidth or tilesize
									tile.height = tile.hitboxheight or tilesize
									if (not collider.collisioncondition) or collider:collisioncondition(tile, axis) then
										updateValuesToReturn(mobtools.doCollisionCheck(axis, collider, tile, ignoreflush))
									end
								end
							end
						else
							local tile = table.copy(content)
							tile.istile = true
							tile.x_tiled = x_tiled
							tile.y_tiled = y_tiled
							tile.x = ((x_tiled - 1) * tilesize) + (tile.hitboxXoffset or 0)
							tile.y = ((y_tiled - 1) * tilesize) + (tile.hitboxYoffset or 0)
							tile.i = i
							local actuallyactive = true
							local thing = tile
							if (not (tile.fake or tile.irrelevant)) and (tile.solid or (collider.collidewith and collider.collidewith[tile.type])) then
								if thing.color then
									if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
									if thing.color_inverse then actuallyactive = not actuallyactive end
								end
								if actuallyactive then
									if (not collider.collisioncondition) or collider:collisioncondition(tile, axis) then
										updateValuesToReturn(mobtools.doCollisionCheck(axis, collider, tile, ignoreflush))
									end
								end
							end
						end
					end
					if level.objmap[y_tiled] and level.objmap[y_tiled][x_tiled] then
						for i=1, #level.objmap[y_tiled][x_tiled] do
							local obj = level.objmap[y_tiled][x_tiled][i]
							if (not caughtobjects[obj]) and (obj ~= collider) then
								local actuallyactive = true
								local thing = obj
								if (not (thing.fake or thing.irrelevant)) and (thing.solid or (collider.collidewith and collider.collidewith[thing.type])) then
									if thing.color then
										if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
										if thing.color_inverse then actuallyactive = not actuallyactive end
									end
									if actuallyactive then
										if (not collider.collisioncondition) or collider:collisioncondition(obj, "overlap") then
											caughtobjects[obj] = true
											updateValuesToReturn(mobtools.doCollisionCheck(axis, collider, obj, ignoreflush))
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	return collisiondir, suggestedposition, collidees
end

function mobtools.doOverlapScan(collider, objectsonly, level)
	local caughtobjects = {}
	
	level = level or collider.level
	local collidees = {}
	--if not objectsonly then
	if true then --objectsonly was a lag-reducing thing that is no longer necessary due to techniques that prevent overlap scan/collision scan from checking tiles the object isn't near
		local collider_rightedge = (collider.x) + collider.width
		local collider_leftedge = (collider.x)
		local collider_top = (collider.y)
		local collider_bottom = (collider.y) + collider.height
		--local collider_rightedge = (collider.x) + collider.width - 1
		--local collider_leftedge = (collider.x)
		--local collider_top = (collider.y)
		--local collider_bottom = (collider.y) + collider.height - 1
		
		local topbound = collider_top
		local bottombound = collider_bottom
		topbound = math.floor(((topbound) / tilesize)) + 1
		bottombound = math.ceil(((bottombound) / tilesize)) + 1
		local leftbound = collider_leftedge
		local rightbound = collider_rightedge
		leftbound = math.floor(((leftbound) / tilesize)) + 1
		rightbound = math.ceil(((rightbound) / tilesize)) + 1
		
		if topbound < 1 then topbound = 1 end
		if bottombound > #level.tilemap then bottombound = #level.tilemap end
		if leftbound < 1 then leftbound = 1 end
		if rightbound > #level.tilemap[1] then rightbound = #level.tilemap[1] end
		
		for y_tiled=topbound, bottombound do
			for x_tiled=leftbound, rightbound do
				--mark((x_tiled - 1) * tilesize, (y_tiled - 1) * tilesize)
				for i=1, #level.tilemap[y_tiled][x_tiled] do
					local content = level.tilemap[y_tiled][x_tiled][i]
					if type(content) == "string" then
						local tile = table.copy(tiles[content])
						local actuallyactive = true
						local thing = tile
						if (not thing.fake) then
							if thing.color then
								if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
								if thing.color_inverse then actuallyactive = not actuallyactive end
							end
							if actuallyactive then
								tile.type = level.tilemap[y_tiled][x_tiled][i]
								tile.istile = true
								tile.x_tiled = x_tiled
								tile.y_tiled = y_tiled
								tile.i = i
								tile.x = ((x_tiled - 1) * tilesize) + (tile.hitboxXoffset or 0)
								tile.y = ((y_tiled - 1) * tilesize) + (tile.hitboxYoffset or 0)
								tile.hmom = 0
								tile.vmom = 0
								tile.width = tile.hitboxwidth or tilesize
								tile.height = tile.hitboxheight or tilesize
								if (not collider.overlapcondition) or collider:overlapcondition(tile) then
									if mobtools.doOverlapCheck(collider, tile) then table.insert(collidees, tile) end
								end
							end
						end
					else
						local tile = table.copy(content)
						tile.istile = true
						tile.x_tiled = x_tiled
						tile.y_tiled = y_tiled
						tile.x = ((x_tiled - 1) * tilesize) + (tile.hitboxXoffset or 0)
						tile.y = ((y_tiled - 1) * tilesize) + (tile.hitboxYoffset or 0)
						tile.i = i
						local actuallyactive = true
						local thing = tile
						if (not thing.fake) then
							if thing.color then
								if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
								if thing.color_inverse then actuallyactive = not actuallyactive end
							end
							if actuallyactive then
								if (not collider.overlapcondition) or collider:overlapcondition(tile) then
									if mobtools.doOverlapCheck(collider, tile) then table.insert(collidees, tile) end
								end
							end
						end
					end
				end
				if level.objmap[y_tiled] and level.objmap[y_tiled][x_tiled] then
					for i=1, #level.objmap[y_tiled][x_tiled] do
						local obj = level.objmap[y_tiled][x_tiled][i]
						if (not (obj.fake or obj.irrelevant)) and (not caughtobjects[obj]) and obj ~= collider then
							--if not ((collider.passive and obj.passive) or (obj.irrelevant) or (obj.player and not obj.alive)) then
							local actuallyactive = true
							local thing = obj
							if thing.color then
								if game.solid_colors[thing.color] then actuallyactive = true else actuallyactive = false end
								if thing.color_inverse then actuallyactive = not actuallyactive end
							end
							if actuallyactive then
								if (not collider.overlapcondition) or collider:overlapcondition(obj) then
									caughtobjects[obj] = true
									if mobtools.doOverlapCheck(collider, obj) then table.insert(collidees, obj) end
								end
							end
						end
					end
				end
			end
		end
	end
	--[[
	for i=1, #level.objects do
		obj = level.objects[i]
		if not ((collider.passive and obj.passive) or (obj.irrelevant) or (obj.player and not obj.alive)) then
			if not collider.overlapcondition or collider:overlapcondition(tile) then
				if mobtools.doOverlapCheck(collider, obj) then table.insert(collidees, obj) end
			end
		end
	end
	]]
	return collidees
end

function mobtools.doCollisionCheck(axis, collider, collidee, ignoreflush)
	local debugge = false
	
	--we enjoy typing. mirroring stuff from docollisionscan
	--i wish i was working in some environment where code efficiency actually matters and i can't just pile up stupid bullshit everywhere
	local dir = "none"
	if axis == "horizontal" then
		if collider.hmom < 0 then dir = "left"
		elseif collider.hmom > 0 then dir = "right" end
	elseif axis == "vertical" then
		if collider.vmom < 0 then dir = "up"
		elseif collider.vmom > 0 then dir = "down" end
	end
	local collisiondir = "none"
	local suggestedposition = nil
	local collidees = {}
	
	if collidee.collsides and not collidee.collsides[consts.oppositedirs[dir]] then
		if debugge then
			frameadvance = true
			print("collsides bypass!")
			print(collidee.type)
			print(dir)
			for k,v in pairs(collidee.collsides) do print(k,v) end
			print("----")
		end
		return collisiondir, suggestedposition, collidees
	elseif collidee.collsides then
		if debugge then
			frameadvance = true
			print("checking colliding with a collsides :)")
		end
	end
	--if collidee.duckthrough and ((collider.ducking or collider.justducked) and not collider.ghost) then return collisiondir, suggestedposition, collidees end
	if collidee.duckthrough and (collider.ducking or collider.duckingthrough) then return collisiondir, suggestedposition, collidees end
	
	--local collider_rightedge = (collider.x) + collider.width - 1 --this is really weird. why is 1 always subtracted for right edges and bottom edges? i guess it's to get the top-left of the edge pixel, for whatever reason. (well, "pixel", since colliders and collidees can be at noninteger coordinates.) later 1 gets subtracted again (in a way that cancels out the - 1 here i think) to check if "ogmo is flush with the wall" so this seems to be intentional and at least somewhat accounted for
	local collider_rightedge = (collider.x) + collider.width
	local collider_leftedge = (collider.x)
	local collidee_rightedge = (collidee.x) + collidee.width
	local collidee_leftedge = (collidee.x)
	local collider_bottom = (collider.y) + collider.height
	local collider_top = (collider.y)
	local collidee_bottom = (collidee.y) + collidee.height
	local collidee_top = (collidee.y)
	
	--force things to be inbounds of the level
	if collider_rightedge < (1/16) then collider_rightedge = (1/16) end
	if collider_top > (collider.level.height - (1/16)) then collider_top = (collider.level.height - (1/16)) end
	if collider_leftedge > (collider.level.width - (1/16)) then collider_leftedge = (collider.level.width - (1/16)) end
	if collider_bottom < (1/16) then collider_bottom = (1/16) end
	
	if collidee.collsides then
		--logic to make it so if the collider is already physically past/inside a collidee with collsides set, nothing happens
		--+1 added as part of the weird "collisions are checked based on the TOP-LEFT of each pixel" scheme
		--not anymore sorry
		local doreturn = false
		if dir == "right" and collider_rightedge > collidee_leftedge then doreturn = true
		elseif dir == "left" and collider_leftedge < collidee_rightedge then doreturn = true
		elseif dir == "down" and collider_bottom > collidee_top then doreturn = true
		elseif dir == "up" and collider_top < collidee_bottom then doreturn = true
		end
		if doreturn then
			if debugge then
				frameadvance = true
				print("yep, already inside collsides, ok go through")
				print(dir)
				print(collidee_rightedge, collider_leftedge)
				print("--------")
			end
			return collisiondir, suggestedposition, collidees
		end
	end
	
	local function updateValuesToReturn (newcollisiondir, newsuggestedposition, newcollidees) --if you change this, change the matching function in doCollisionScan
		if collisiondir == "none" then collisiondir = newcollisiondir end
		
		--make sure suggested position is always whichever position would make the player collide earlier
		if newsuggestedposition ~= nil then
			if suggestedposition == nil then suggestedposition = newsuggestedposition else
					if (dir == "left"  or dir == "up")   and newsuggestedposition > suggestedposition then suggestedposition = newsuggestedposition
				elseif (dir == "right" or dir == "down") and newsuggestedposition < suggestedposition then suggestedposition = newsuggestedposition end
			end
		end
		
		if newcollidees == nil then print("newcollidees is nil"); newcollidees = {} end
		
		for k,v in ipairs(newcollidees) do
			table.insert(collidees, v)
		end
	end
	
	local y_min
	local y_max
	local x_min
	local x_max
	local wontcollide = false
	if axis == "horizontal" and collider_top < collidee_bottom and collider_bottom > collidee_top then
		--debug
		if frameadvance then
			print("collider top & bottom:", collider_top, collider_bottom)
			print("collidEE top & bottom:", collidee_top, collidee_bottom)
		end
		if collidee.mask then --note: collidee's mask will be checked, but NOT collider's
			y_min = (math.floor(collider_top) - collidee_top) + 1 --top of collider relative to mask, plus 1 because this is calculated using 0-indexing (screen coordinates) but is now being used for a table which uses 1-indexing
			y_max = (math.ceil(collider_bottom) - collidee_top) --bottom of collider relative to mask, except not plus 1 for reasons i dont fully understand
			local oldy_min = y_min
			local oldy_max = y_max
			
			if y_min > collidee.height then
				print("y_min: " .. tostring(y_min))
				print("y_max: " .. tostring(y_max))
				print("collider info")
				print(collider.height, collider_top, collider_bottom)
				print("collidee info")
				print(collidee.height, collidee_top, collidee_bottom)
				error("this probably shouldn't be happening")
			end
			
			if y_min < 1 then y_min = 1 end
			if y_max < 1 then wontcollide = true end
			if y_max > collidee.height then y_max = collidee.height end
			if y_min > collidee.height then wontcollide = true end
			if wontcollide then error("yeah the thing you thought would never come up again ceme up again") end
		end
		if not wontcollide then
			if dir == "right" then
				if collidee_rightedge > collider_rightedge then --if right edge of tile is to the right of right edge of player. this means player is potentially able to collide with the block or any mask pixels of the block
					if ((not ignoreflush) and collider_rightedge + collider.hmom >= collidee_leftedge) or
						(collider_rightedge + collider.hmom > collidee_leftedge) then --checks if collider's right edge plus their horizontal momentum would bring them past or at the left edge of the tile
						if not collidee.mask then
							updateValuesToReturn("right", collidee_leftedge - collider.width, {collidee})
						else
							--what we do for mask collision is, basically: figure out what area a mask pixel needs to be in for ogmo to collide with it given ogmo's current momentum, then if a pixel is found in that area, set ogmo flush against it and cancel his momentum
							local x_min = math.floor(collider_rightedge - collidee_leftedge) + 1
							local x_max = x_min + math.ceil(collider.hmom)
							if x_min < 1 then x_min = 1 end
							if x_max > collidee.width then x_max = collidee.width end
							local x_mask = x_min
							local y_mask = y_min
							while x_mask <= x_max do
								if not collidee.mask[y_mask] then print(y_max, y_min, y_mask) end
								if collidee.mask[y_mask][x_mask] then
									--frameadvance = true
									--print("mask pixel found at " .. tostring(x_mask) .. "," .. tostring(y_mask))
									--print("y_min: " .. tostring(y_min) .. ", y_max: " .. tostring(y_max))
									updateValuesToReturn("right", (x_mask - 1) + collidee_leftedge - collider.width, {collidee})
								end
								y_mask = y_mask + 1
								if y_mask > y_max then
									y_mask = y_min
									x_mask = x_mask + 1
								end
							end
						end
					end
				end
			elseif dir == "left" then
				if collidee_leftedge < collider_leftedge then
					if ((not ignoreflush) and collider_leftedge + collider.hmom <= collidee_rightedge) or
						(collider_leftedge + collider.hmom < collidee_rightedge) then
						if not collidee.mask then
							updateValuesToReturn("left", collidee_rightedge, {collidee})
						else
							local x_max = math.ceil(collider_leftedge - collidee_leftedge) + 1
							local x_min = x_max + math.floor(collider.hmom)
							if x_min < 1 then x_min = 1 end
							if x_max > collidee.width then x_max = collidee.width end
							local x_mask = x_max
							local y_mask = y_min
							while x_mask >= x_min do
								if not collidee.mask[y_mask] then print(y_max, y_min, y_mask) end
								if collidee.mask[y_mask][x_mask] then
									updateValuesToReturn("left", (x_mask) + collidee_leftedge, {collidee})
								end
								y_mask = y_mask + 1
								if y_mask > y_max then
									y_mask = y_min
									x_mask = x_mask - 1
								end
							end
						end
					end
				end
			end
		end
	elseif axis == "vertical" and collider_leftedge < collidee_rightedge and collider_rightedge > collidee_leftedge then
		if collidee.mask then --note: collidee is allowed to have a mask, but NOT collider
			x_min = (math.floor(collider_leftedge) - collidee_leftedge) + 1
			x_max = (math.ceil(collider_rightedge) - collidee_leftedge)
			if x_min < 1 then x_min = 1 end
			if x_max < 1 then wontcollide = true end
			if x_max > collidee.height then x_max = collidee.height end
			if x_min > collidee.height then wontcollide = true end
			if wontcollide then error("yeah the thing you thought would never come up again ceme up again") end
		end
		if not wontcollide then
			if dir == "down" then
				if collidee_bottom > collider_bottom then
					if ((not ignoreflush) and collider_bottom + collider.vmom >= collidee_top) or
						(collider_bottom + collider.vmom > collidee_top) then
						if not collidee.mask then
							updateValuesToReturn("down", collidee_top - collider.height, {collidee})
						else
							local y_min = math.floor(collider_bottom - collidee_top) + 1
							local y_max = y_min + math.ceil(collider.vmom)
							if y_min < 1 then y_min = 1 end
							if y_max > collidee.height then y_max = collidee.height end
							local y_mask = y_min
							local x_mask = x_min
							while y_mask <= y_max do
								if not collidee.mask[y_mask] then print(y_max, y_min, y_mask) end
								if collidee.mask[y_mask][x_mask] then
									updateValuesToReturn("down", (y_mask - 1) + collidee_top - collider.height, {collidee})
								end
								x_mask = x_mask + 1
								if x_mask > x_max then
									x_mask = x_min
									y_mask = y_mask + 1
								end
							end
						end
					end
				end
			elseif dir == "up" then
				if collidee_top < collider_top then
					if ((not ignoreflush) and collider_top + collider.vmom <= collidee_bottom) or
						(collider_top + collider.vmom < collidee_bottom) then
						if not collidee.mask then
							updateValuesToReturn("up", collidee_bottom, {collidee})
						else
							local y_max = math.ceil(collider_top - collidee_top) + 1
							local y_min = y_max + math.floor(collider.vmom)
							if y_min < 1 then y_min = 1 end
							if y_max > collidee.height then y_max = collidee.height end
							local y_mask = y_max
							local x_mask = x_min
							while y_mask >= y_min do
								if not collidee.mask[y_mask] then print(y_max, y_min, y_mask) end
								if collidee.mask[y_mask][x_mask] then
									updateValuesToReturn("up", (y_mask) + collidee_top, {collidee})
								end
								x_mask = x_mask + 1
								if x_mask > x_max then
									x_mask = x_min
									y_mask = y_mask - 1
								end
							end
						end
					end
				end
			end
		end
	end
	return collisiondir, suggestedposition, collidees
end

function mobtools.doOverlapCheck(collider, collidee)
	--this is simpler than docollisioncheck because we don't need a collision direction or suggested position, just whether or not the -er and -ee overlap
	local collider_rightedge = (collider.x) + collider.width
	local collider_leftedge = (collider.x)
	local collidee_rightedge = (collidee.x) + collidee.width
	local collidee_leftedge = (collidee.x)
	local collider_bottom = (collider.y) + collider.height
	local collider_top = (collider.y)
	local collidee_bottom = (collidee.y) + collidee.height
	local collidee_top = (collidee.y)
	if collider_top < collidee_bottom and collider_bottom > collidee_top then
		if collider_leftedge < collidee_rightedge and collider_rightedge > collidee_leftedge then
			if (not collidee.mask) and (not collider.mask) then
				return true
			elseif (collidee.mask and not collider.mask) or (collider.mask and not collidee.mask) then
				local collider = collider
				local collidee = collidee
				if not collidee.mask then
					collider, collidee = collidee, collider
					collider_top, collidee_top = collidee_top, collider_top
					collider_bottom, collidee_bottom = collidee_bottom, collider_bottom
					collider_leftedge, collidee_leftedge = collidee_leftedge, collider_leftedge
					collider_rightedge, collidee_rightedge = collidee_rightedge, collider_rightedge
				end
				local y_min = (math.floor(collider_top) - math.floor(collidee_top)) + 1
				local y_max = (math.ceil(collider_bottom) - math.floor(collidee_top))
				local x_min = (math.floor(collider_leftedge) - math.floor(collidee_leftedge)) + 1
				local x_max = (math.ceil(collider_rightedge) - math.floor(collidee_leftedge))
				if y_min < 1 then y_min = 1 end
				if y_max > collidee.height then y_max = collidee.height end
				if x_min < 1 then x_min = 1 end
				if x_max > collidee.width then x_max = collidee.width end
				local y_mask = y_min --for the longest time this was y_max for some reason and it caused really weird collision bugs since only one row of the mask ever got scanned
				local x_mask = x_min
				while y_mask <= y_max do
					if collidee.mask[y_mask] == nil then
						print(y_min, y_mask, y_max)
					elseif collidee.mask[y_mask][x_mask] == nil then
						print(x_min, x_mask, x_max)
					end
					if collidee.mask[y_mask][x_mask] then
						return true
					end
					x_mask = x_mask + 1
					if x_mask > x_max then
						x_mask = x_min
						y_mask = y_mask + 1
					end
				end
			else
				--two masked objects checking if they overlap isn't supported yet
			end
		end
	end
	return false
end

function mobtools.doPastEdgeScan(collider, dir, level)
	--unfinished. should ideally be checking masks at some point
	level = level or collider.level
	local collidees = {}
	
	local collider_rightedge = (collider.x) + collider.width
	local collider_leftedge = (collider.x)
	local collider_bottom = (collider.y) + collider.height
	local collider_top = (collider.y)
	
	local topbound = collider_top
	local bottombound = collider_bottom
	topbound = math.floor(((topbound) / tilesize) + 1)
	bottombound = math.floor(((bottombound) / tilesize) + 1)
	local leftbound = collider_leftedge
	local rightbound = collider_rightedge
	leftbound = math.floor(((leftbound) / tilesize) + 1)
	rightbound = math.floor(((rightbound) / tilesize) + 1)
	
	if dir == "right" then rightbound = rightbound + 1
	elseif dir == "left" then leftbound = leftbound - 1
	elseif dir == "down" then bottombound = bottombound + 1
	elseif dir == "up" then topbound = topbound - 1
	end
	
	if topbound < 1 then topbound = 1 end
	if bottombound > #level.tilemap then bottombound = #level.tilemap end
	if leftbound < 1 then leftbound = 1 end
	if rightbound > #level.tilemap[1] then rightbound = #level.tilemap[1] end
	
	for y_tiled=topbound, bottombound do
		for x_tiled=leftbound, rightbound do
			if level.objmap[y_tiled] and level.objmap[y_tiled][x_tiled] then
				for i=1, #level.objmap[y_tiled][x_tiled] do
					local obj = level.objmap[y_tiled][x_tiled][i]
					if not collider.pastedgecondition or collider:pastedgecondition(obj) then
						if mobtools.doPastEdgeCheck(collider, obj, dir) then table.insert(collidees, obj) end
					end
				end
			end
		end
	end
	return collidees
end

function mobtools.doPastEdgeCheck(collider, collidee, dir)
	local collider_rightedge = (collider.x) + collider.width
	local collider_leftedge = (collider.x)
	local collidee_rightedge = (collidee.x) + collidee.width
	local collidee_leftedge = (collidee.x)
	local collider_bottom = (collider.y) + collider.height
	local collider_top = (collider.y)
	local collidee_bottom = (collidee.y) + collidee.height
	local collidee_top = (collidee.y)
	--local collider_rightedge = (collider.x) + collider.width - 1
	--local collider_leftedge = (collider.x)
	--local collidee_rightedge = (collidee.x) + collidee.width - 1
	--local collidee_leftedge = (collidee.x)
	--local collider_bottom = (collider.y) + collider.height - 1
	--local collider_top = (collider.y)
	--local collidee_bottom = (collidee.y) + collidee.height - 1
	--local collidee_top = (collidee.y)
	local horizontallyaligned = collider_top <= collidee_bottom and collider_bottom >= collidee_top
	local verticallyaligned   = collider_leftedge <= collidee_rightedge and collider_rightedge >= collidee_leftedge
		if dir == "left"  then
			local condition1 = collidee_rightedge <= collider_leftedge
			local condition2 = horizontallyaligned
			return condition1 and condition2
	elseif dir == "right" then
			local condition1 = collidee_leftedge >= collider_rightedge
			local condition2 = horizontallyaligned
			return condition1 and condition2
	elseif dir == "up"    then
			local condition1 = collidee_bottom <= collider_top
			local condition2 = verticallyaligned
			return condition1 and condition2
	elseif dir == "down"  then
			local condition1 = collidee_top >= collider_bottom
			local condition2 = verticallyaligned
			return condition1 and condition2
	else error("invalid direction given for pastedgescan", 3) end
	return false
end