object = class:new()
--obj = object --"obj" is used as a local variable a lot, and this abbreviation was never actually used anywhere except for win.lua

object.type = "unknown"
object.default_obj_img = graphics.load("default_obj")

function object:init(x, y)
	self.x = x
	self.y = y
	self.hmom = 0
	self.ymom = 0
	self.width = tilesize
	self.height = tilesize
end

--this is what's responsible for the silent tag functioning
function object:playsfx(...)
	if self.tags and self.tags.silent then
		audio.setpitch(1) --Resetting the pitch is part of audio.playsfx.
		return
	end
	audio.playsfx(...)
end

--ideally objects should be able to have NO update function or draw function and not count for update/draw loop iteration, so they shouldn't inherit it
--[[
function object:update() end

function object:draw()
	local myimage = graphics.load(object.type) or graphics.load("default_obj")
	love.graphics.draw(myimage, self.x, self.y)
end
]]

object.my_test_value = "zoinks"