statemachine = {
	states = {
		["game"] = game,
		["menu"] = menu,
		["editor"] = editor,
		["symboldisplay"] = symboldisplay,
		["youwin"] = youwin,
	},
	currentstate = menu,
	overlaystate = nil,
	dontdrawunderneath = false
}

function statemachine.setstate(state, statename)
	ih8ui.showingbox = false
	statemachine.dontdrawunderneath = false
	if type(state) == "string" then
		statename = state
	end
	print ("statemachine: changing to state \"" .. statename .. "\"!")
	statemachine.currentstate.stop(statename)
	if statemachine.overlaystate then statemachine.overlaystate.stop(statename, true) end
	statemachine.overlaystate = nil
	local previousstate = statemachine.currentstate
	if type(state) == "string" then
		statemachine.currentstate = statemachine.states[statename]
	else
		statemachine.currentstate = state
	end
	statemachine.currentstate.begin(previousstate)
end

function statemachine.setoverlaystate(state)
	print("statemachine: setting overlay state to \"" .. state .. "\"!")
	statemachine.overlaystate = statemachine.states[state]
	statemachine.overlaystate.begin(statemachine.currentstate, true)
end

function statemachine.clearoverlaystate()
	print("statemachine: clearing overlay state!")
	statemachine.dontdrawunderneath = false
	if statemachine.overlaystate then statemachine.overlaystate.stop(state, true) end
	statemachine.overlaystate = nil
end

function statemachine.getactivestate()
	if statemachine.overlaystate then return statemachine.overlaystate
	else return statemachine.currentstate end
end